*CMZ :  2.01/01 17/05/95  15.54.19  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   23/03/95

      INTEGER FUNCTION CHIND1 (CTXT, C1)

************************************************************************
*
* Description: position of character ch1 in character string CTXT.
*              same as Fortran INDEX but (i) it is case insensitive
*              (ii) CH1 must consist of one character.
*
* Called from: anywhere
*
* External references: none
*
* Argument in/out description
*   CTXT   in     any character string
*   CH1    in     1 character
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"

      CHARACTER CTXT*(*), C1*1, CL*1, CU*1

#include "arte/Arte.ff"

      CL = LOWER(C1)
      CU = UPPER(C1)

      DO 10 CHIND1 = 1, LEN(CTXT)
 10   IF (CTXT(CHIND1:CHIND1) .EQ. CL .OR. CTXT(CHIND1:CHIND1) .EQ. CU)
     +  GO TO 90
      CHIND1 = 0

 90   END

************************************************************************
* End of CHIND1
************************************************************************
