
/**********************************************************************/
//
// $Source: /afs/desy.de/group/hera-b/repository/ARTE/cluearte/UtaConversions.C,v $
// $Revision: 1.5 $
// $Author: natasha $
// $Date: 1999/11/02 17:44:58 $
//
// Created: 03-03-99,   C. Borgmeier
//
/**********************************************************************/

#include <cmath>

#include <Clue/UtaConversions.h>


template<class T>
UtaPar3DInvMom convert( T rtra )
{
  int q = ( rtra!=0 ) ? ( rtra->pf<0? -1: 1 ): 0;
  return rtra!=0 ?UtaPar3DInvMom
    ( UtaPar3D( rtra->xf, rtra->yf, rtra->txf, rtra->tyf, rtra->zf,
		rtra->cvf[0], rtra->cvf[1], rtra->cvf[3], rtra->cvf[6],
                              rtra->cvf[2], rtra->cvf[4], rtra->cvf[7],
                                            rtra->cvf[5], rtra->cvf[8],
                                                          rtra->cvf[9] ),
      std::fabs( rtra->pf ),
      q*rtra->cvf[10],
      q*rtra->cvf[11],
      q*rtra->cvf[12],
      q*rtra->cvf[13],
      rtra->cvf[14] )
    : UtaPar3DInvMom();
}


template UtaPar3DInvMom convert( ArtePointer<RTRA> rtra );
template UtaPar3DInvMom convert( ArtePointer<RSEG> rseg );
