 
// *****************************************************************************
//
// source:    DQ_ITR_rec_evnt.C
//
// type:      source code
//
// created:   26 Jun 2000
//
// author:    Dr. Andreas Gellrich
//            HERA-B Collaboration
//            Humboldt-University Berlin
//            Physics Department
//            Invalidenstr. 110
//            10115 Berlin
//            Germany
//            email: Andreas.Gellrich@desy.de
//
// called by: DQ_event()
//
// changes:
// 26 Jun 2000 (AG) creation
//
// ******************************************************************

// standard includes
#include <stdlib.h>
#include <stdio.h>

// ONLINE includes
#include "rhp.h"
#include "event.h"

// Arte includes
#include "arte/arte.hh"
#include "farm/farm.hh"
#include "dq/DQ.h"
#include "dq/DQ_ITR.h"

//
// function code
//
int
DQ_ITR_rec_evnt()
{
  // show up
  ARTE_mark( "DQ_ITR_rec_evnt 0", 0 );

  //unsigned int histogram_id1 = 1;     // 0x0     lowest
  //unsigned int histogram_id2 = 65535; // 0xfffff highest

  //float x_value = 0; // containing the x-value to be histogrammed
  //float y_value = 0; // containing the y-value to be histogrammed
 
  // print (online to grr)
  //ARTE_error( GRR_SFATAL, "I am dead!", 99 );
  
  // 1-dim histogram
  //rhp_hf1( DQ_ID( COMP_ITR, LVL_REC, histogram_id1 ), x_value, 1 );
  
  // 2-dim histogfram
  //rhp_hfill( DQ_ID( COMP_ITR, LVL_REC, histogram_id2 ), x_value, y_value, 1 );

  ARTE_mark( "DQ_ITR_rec_evnt 1", 0 );
  return 0; // return error code (0 = okay)
}
