
// ******************************************************************
//
// D. Samtleben 10 Aug 1999
//
// Filling of histograms
//
// changes:
// 28 Oct 1999 (AG) use defines from DQ.h
//  1 Nov 1999 (AG) get rid of dq_hid.h
//
// ******************************************************************

// standard includes
#include <stdlib.h>
#include <stdio.h>

// ONLINE includes
#include "rhp.h"
#include "event.h"

// Arte includes
#include "arte/arte.hh"
#include "dq/DQ.h"
#include "dq/DQ_OTR.h"

//
// function code
//
int
DQ_OTR_hit_evnt()
{
  float NrOTRHits=0;
  float NrOTRHitsMC01=0;
  float NrOTRHitsMC02=0;
  float NrOTRHitsPC04=0;
  float NrOTRHitsTC01=0;
  float NrOTRHitsTC02=0;
//====================================================================
//      OTR stuff
//====================================================================
for( ArteTableIterator<HITB> hitb; hitb.valid(); hitb.next() ){
 
      ArtePointer<GEDE> gede(hitb->gede); 

      if(gede->cmp==2){
           NrOTRHits++;
          if(strncmp(gede->gesl->name,"MC01",4)==0)
            {
              NrOTRHitsMC01++;
              /* fill plane minus first plane */
              rhp_hf1(DQ_ID(COMP_OTR,LVL_HIT,100100),gede.index(),1);
              //rhp_hf1(DQ_ID(COMP_OTR,LVL_HIT,100000+gede->sec+10*(gede->lay-1)-1),hitb->x,1);
              //rhp_hf1(DQ_ID(COMP_OTR,LVL_HIT,110000+gede->sec+10*(gede->lay-1)-1),hitb->y,1);
            }
          if(strncmp(gede->gesl->name,"MC02",4)==0)
            {
              NrOTRHitsMC02++;
              /* fill plane minus first plane */
              rhp_hf1(DQ_ID(COMP_OTR,LVL_HIT,200100),gede.index(),1);
              //rhp_hf1(DQ_ID(COMP_OTR,LVL_HIT,200000+gede->sec+10*(gede->lay-1)-1),hitb->x,1);
              //rhp_hf1(DQ_ID(COMP_OTR,LVL_HIT,210000+gede->sec+10*(gede->lay-1)-1),hitb->y,1);
            }
          if(strncmp(gede->gesl->name,"PC04",4)==0)
{
              NrOTRHitsPC04++;
              /* fill plane minus first plane */
              rhp_hf1(DQ_ID(COMP_OTR,LVL_HIT,300100),gede.index(),1);
              //rhp_hf1(DQ_ID(COMP_OTR,LVL_HIT,300000+gede.index()-gede->gesl->fpl),hitb->x,1);
              //rhp_hf1(DQ_ID(COMP_OTR,LVL_HIT,310000+gede.index()-gede->gesl->fpl),hitb->y,1);
            }
          if(strncmp(gede->gesl->name,"TC01",4)==0)
            {
              NrOTRHitsTC01++;
              /* fill plane minus first plane */
              rhp_hf1(DQ_ID(COMP_OTR,LVL_HIT,400100),gede.index(),1);
              //rhp_hf1(DQ_ID(COMP_OTR,LVL_HIT,400000+gede.index()-gede->gesl->fpl),hitb->x,1);
              //rhp_hf1(DQ_ID(COMP_OTR,LVL_HIT,410000+gede.index()-gede->gesl->fpl),hitb->y,1);
            }
          if(strncmp(gede->gesl->name,"TC02",4)==0)
            {
              NrOTRHitsTC02++;
              /* fill plane minus first plane */
              rhp_hf1(DQ_ID(COMP_OTR,LVL_HIT,500100),gede.index(),1);
              //rhp_hf1(DQ_ID(COMP_OTR,LVL_HIT,500000+gede.index()-gede->gesl->fpl),hitb->x,1);
              //rhp_hf1(DQ_ID(COMP_OTR,LVL_HIT,510000+gede.index()-gede->gesl->fpl),hitb->y,1);
            }
}
}
  return 0; // return error code (0 = okay)
}
