// ********************************************************************
//
//  Routine:      kagagestore
//  Author:       T.Oest
//
//  Description:  store alca table to database
//
//
// ********************************************************************

#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "arte/arte.hh"
#include <time.h>
 
extern "C" void kugeti_(int*);
extern "C" void kugetr_(float*);
extern "C" void kugetc_( char*, int *, int );

void ackuexec(char * KuipCommand);
 

extern "C" void kagagestore_() {

//---------------------------------------------------------------
//   read in component to be aligned
//---------------------------------------------------------------

  int monat, day, hour, min, sec, year;
 
  struct tm tmTime;
  tmTime.tm_year = 99;
  tmTime.tm_isdst =  1;
 
  kugeti_(&day);
  kugeti_(&monat);
  kugeti_(&year);
  kugeti_(&hour);
  kugeti_(&min);
  kugeti_(&sec);

  tmTime.tm_year  = year;
  tmTime.tm_mon   = monat - 1;
  tmTime.tm_mday  = day;
  tmTime.tm_hour  = hour;
  tmTime.tm_min   = min;
  tmTime.tm_sec   = sec;

   int ptime;
   int * utime = &ptime;
   *utime = mktime( &tmTime );

   cout << "Requested Date & Time" << asctime( &tmTime ) << endl;
   cout << "This converts to unix-time in sec after the epoch: " << *utime << endl;;
 

//---------------------------------------------------------------
//   read in database file
//---------------------------------------------------------------

  int len;
  char input[20];
  int len1 = 19;
  kugetc_(input, &len, len1);
  input[len] = 0;

  char *dbfile;
  dbfile  = (char *) malloc(len+1);
  dbfile[len] = 0;

  if(len>0) for(int i=0; i<len; i++) dbfile[i] = input[i];

//---------------------------------------------------------------
//   fill acga row
//---------------------------------------------------------------

    ackuexec("iofile  dbga /SETUP_ALIGN ");
    ackuexec("dbopen  dbga rw");
    ackuexec("dbwrite dbga ACGA  950608800 1");
    ackuexec("dbclose dbga");
 

};
