*-- Author :
      SUBROUTINE PICMUO
*     =================
C     draws a muon detector

      IMPLICIT NONE
C
      REAL ZCUT,Z1,Z2,ZMUON,SCALE
      INTEGER K,NP1,IS,JS,CMP
      CHARACTER*5 PERS
#include "gean/gcflag.fi"
#include "arte/Arte.fi"
#include "auto/NESL.fi"
#include "gean/ZGESL.fi"
#include "arte/ArteFlag.fi"
      DATA NP1 /3/
#include "arte/Arte.ff"
#include "auto/NESL.ff"

C----------------------
* middle Z of MUON
      ZMUON=0.
      DO IS=1,IQ(JNESL+2)
        JS=JNESL+IQ(JNESL+1)*(IS-1)+2
        CMP=IQ(JS+JNESL_CMP)
        IF(CMP.EQ.LGESL_MUON) THEN
          Z1=Q(JS+JNESL_Z1)
          Z2=Q(JS+JNESL_Z2)
          ZMUON=0.5*(Z1+Z2)
        ENDIF
      ENDDO
      IF(ZMUON.EQ.0.) RETURN
      CALL GDOPT('HIDE','ON  ')
      CALL GDOPT('SHAD','ON  ')
      CALL KUGETC(PERS,K)
      IF(PERS.EQ.'P') THEN
         CALL GDRAW('MUON',80.,150.,0.,10.,10.5,.015,.015)
         CALL GDSCAL(2.,4.)
      ELSE IF(PERS.EQ.'ZCUT') THEN
        CALL KUGETR(ZCUT)
        PRINT*,'Zcut=',ZCUT,'   Zmin, Zmax =',Z1,Z2
        CALL GDRAWC('MUON',3,ZCUT-ZMUON,10.,12.,.02,.02)
      ELSE IF(PERS.EQ.'EBC') THEN
        CALL KUGETR(ZCUT)
        PRINT*,'Zcut =',ZCUT,'   Zmin, Zmax =',Z1,Z2
        SCALE=0.2
        CALL GDRAWC('MUON',3,ZCUT-ZMUON,0.,26.,SCALE,SCALE)
      ELSE IF(PERS.EQ.'ZSC') THEN
        CALL KUGETR(ZCUT)
        CALL KUGETR(SCALE)
        PRINT*,'Zcut, SCALE =',ZCUT,SCALE,'   Zmin, Zmax =',Z1,Z2
        CALL GDRAWC('MUON',3,ZCUT-ZMUON,10.,12.,SCALE,SCALE)
      ELSE IF(PERS.EQ.'SIDE') THEN
        CALL GDRAW('MUON',90.,180.,0.,10.,12.,.023,.023)
      ELSE IF(PERS.EQ.'SDN') THEN
        CALL GDOPT('HIDE','OFF ')
        CALL GDOPT('SHAD','OFF ')
        CALL GDRAW('MUON',90.,180.,0.,10.,12.,.023,.023)
        CALL GDOPT('HIDE','ON  ')
        CALL GDOPT('SHAD','ON  ')
      ELSE IF(PERS.EQ.'TOP') THEN
        CALL GDRAWC('MUON',2,0.,10.,10.5,.017,.017)
      ELSE IF(PERS.EQ.'TOPN') THEN
        CALL GDOPT('HIDE','OFF ')
        CALL GDOPT('SHAD','OFF ')
        CALL GDRAWC('MUON',2,0.,10.,10.5,.017,.017)
        CALL GDOPT('HIDE','ON  ')
        CALL GDOPT('SHAD','ON  ')
      ELSE IF(PERS.EQ.'TP0') THEN
        CALL GDRAWC('MUON',2,0.,36.,11.5,.1,.1)
      ELSE IF(PERS.EQ.'TP0N') THEN
        CALL GDOPT('HIDE','OFF ')
        CALL GDOPT('SHAD','OFF ')
        CALL GDRAWC('MUON',2,0.,36.,11.5,.1,.1)
        CALL GDOPT('HIDE','ON  ')
        CALL GDOPT('SHAD','ON  ')
      ELSE IF(PERS.EQ.'TP1') THEN
        CALL GDRAWC('MUON',2,0.,23.,11.5,.1,.1)
      ELSE IF(PERS.EQ.'TP1N') THEN
        CALL GDOPT('HIDE','OFF ')
        CALL GDOPT('SHAD','OFF ')
        CALL GDRAWC('MUON',2,0.,23.,11.5,.1,.1)
        CALL GDOPT('HIDE','ON  ')
        CALL GDOPT('SHAD','ON  ')
      ELSE IF(PERS.EQ.'TP2') THEN
        CALL GDRAWC('MUON',2,0.,-2.,11.5,.08,.08)
      ELSE IF(PERS.EQ.'TP2N') THEN
        CALL GDOPT('HIDE','OFF ')
        CALL GDOPT('SHAD','OFF ')
        CALL GDRAWC('MUON',2,0.,-2.,11.5,.08,.08)
        CALL GDOPT('HIDE','ON  ')
        CALL GDOPT('SHAD','ON  ')
      ELSE IF(PERS.EQ.'LO') THEN
        CALL GDRAWC('MUON',2,0.,3.,11.5,.1,.1)
      ELSE IF(PERS.EQ.'SL1') THEN
          CALL GDOPT('HIDE','OFF ')
          CALL GDOPT('SHAD','OFF ')
          CALL GSATT('MUW1','COLO',1)
          CALL GDRAW('MUD1',0.,0.,0.,10.,10.,.025,.025)
          CALL GSATT('MUW1','COLO',60)
          CALL GDOPT('HIDE','ON  ')
          CALL GDOPT('SHAD','ON  ')
          CALL GDHEAD(1001,
     +    'HERA-B MUON DETECTOR - superlayer 1',.4)
      ELSE IF(PERS.EQ.'SL2') THEN
          CALL GDOPT('HIDE','OFF ')
          CALL GDOPT('SHAD','OFF ')
          CALL GSATT('MUW2','COLO',1)
          CALL GDRAW('MUD2',0.,0.,0.,10.,10.,.025,.025)
          CALL GSATT('MUW2','COLO',60)
          CALL GDOPT('HIDE','ON  ')
          CALL GDOPT('SHAD','ON  ')
          CALL GDHEAD(1001,
     +    'HERA-B MUON DETECTOR - superlayer 2',.4)
      ELSE IF(PERS.EQ.'SL3') THEN
          CALL GDOPT('HIDE','OFF ')
          CALL GDOPT('SHAD','OFF ')
          CALL GSATT('MUP3','COLO',1)
          CALL GDRAW('MUD3',0.,0.,0.,10.,11.,.02,.02)
          CALL GSATT('MUP3','COLO',60)
          CALL GDOPT('HIDE','ON  ')
          CALL GDOPT('SHAD','ON  ')
          CALL GDHEAD(1001,
     +    'HERA-B MUON DETECTOR - superlayer 3',.4)
      ELSE IF(PERS.EQ.'SL4') THEN
          CALL GDOPT('HIDE','OFF ')
          CALL GDOPT('SHAD','OFF ')
          CALL GSATT('MUP4','COLO',1)
          CALL GDRAW('MUD4',0.,0.,0.,10.,10.,.025,.025)
          CALL GSATT('MUP4','COLO',60)
          CALL GDOPT('HIDE','ON  ')
          CALL GDOPT('SHAD','ON  ')
          CALL GDHEAD(1001,
     +    'HERA-B MUON DETECTOR - superlayer 4',.4)
      ELSE IF(PERS.EQ.'SD0') THEN
          CALL GDRAW('MUON',90.,180.,0.,36.,11.5,.1,.1)
      ELSE IF(PERS.EQ.'SD0N') THEN
          CALL GDOPT('HIDE','OFF ')
          CALL GDOPT('SHAD','OFF ')
          CALL GDRAW('MUON',90.,180.,0.,36.,11.5,.1,.1)
          CALL GDOPT('HIDE','ON  ')
          CALL GDOPT('SHAD','ON  ')
      ELSE IF(PERS.EQ.'SD1') THEN
          CALL GDRAW('MUON',90.,180.,0.,23.,11.5,.1,.1)
      ELSE IF(PERS.EQ.'SD1N') THEN
          CALL GDOPT('HIDE','OFF ')
          CALL GDOPT('SHAD','OFF ')
          CALL GDRAW('MUON',90.,180.,0.,23.,11.5,.1,.1)
          CALL GDOPT('HIDE','ON  ')
          CALL GDOPT('SHAD','ON  ')
      ELSE IF(PERS.EQ.'SD2') THEN
          CALL GDRAW('MUON',90.,180.,0., -3.,11.5,.08,.08)
      ELSE IF(PERS.EQ.'SD2N') THEN
          CALL GDOPT('HIDE','OFF ')
          CALL GDOPT('SHAD','OFF ')
          CALL GDRAW('MUON',90.,180.,0., -3.,11.5,.08,.08)
          CALL GDOPT('HIDE','ON  ')
          CALL GDOPT('SHAD','ON  ')
      ELSE IF(PERS.EQ.'SL11') THEN
          ZCUT=1618.6
          CALL GDRAWC('MUON',3,ZCUT-ZMUON,8.5,12.,.02,.02)
      ELSE IF(PERS.EQ.'SL12') THEN
          ZCUT=1624.5
          CALL GDRAWC('MUON',3,ZCUT-ZMUON,8.5,12.,.02,.02)
      ELSE IF(PERS.EQ.'SL13') THEN
          ZCUT=1630.4
          CALL GDRAWC('MUON',3,ZCUT-ZMUON,8.5,12.,.02,.02)
      ELSE IF(PERS.EQ.'SL14') THEN
          ZCUT=1636.3
          CALL GDRAWC('MUON',3,ZCUT-ZMUON,8.5,12.,.02,.02)
      ELSE IF(PERS.EQ.'SL15') THEN
          ZCUT=1641.9
          CALL GDRAWC('MUON',3,ZCUT-ZMUON,8.5,12.,.02,.02)
      ELSE IF(PERS.EQ.'SL16') THEN
          ZCUT=1647.4
          CALL GDRAWC('MUON',3,ZCUT-ZMUON,8.5,12.,.02,.02)
      ELSE IF(PERS.EQ.'SL21') THEN
          ZCUT=1745.
          CALL GDRAWC('MUON',3,ZCUT-ZMUON,8.5,12.,.02,.02)
      ELSE IF(PERS.EQ.'SL22') THEN
          ZCUT=1751.
          CALL GDRAWC('MUON',3,ZCUT-ZMUON,8.5,12.,.02,.02)
      ELSE IF(PERS.EQ.'SL23') THEN
          ZCUT=1757.
          CALL GDRAWC('MUON',3,ZCUT-ZMUON,8.5,12.,.02,.02)
      ELSE IF(PERS.EQ.'SL24') THEN
          ZCUT=1763.2
          CALL GDRAWC('MUON',3,ZCUT-ZMUON,8.5,12.,.02,.02)
      ELSE IF(PERS.EQ.'SL25') THEN
          ZCUT=1769.
          CALL GDRAWC('MUON',3,ZCUT-ZMUON,8.5,12.,.02,.02)
      ELSE IF(PERS.EQ.'SL31') THEN
          ZCUT=1880.
          CALL GDRAWC('MUON',3,ZCUT-ZMUON,10.,12.,.02,.02)
      ELSE IF(PERS.EQ.'SL32') THEN
          ZCUT=1880.6
          CALL GDRAWC('MUON',3,ZCUT-ZMUON,10.,12.,.02,.02)
      ELSE IF(PERS.EQ.'SL33') THEN
          ZCUT=1886.5
          CALL GDRAWC('MUON',3,ZCUT-ZMUON,10.,12.,.02,.02)
      ELSE IF(PERS.EQ.'SL34') THEN
          ZCUT=1887.
          CALL GDRAWC('MUON',3,ZCUT-ZMUON,10.,12.,.02,.02)
      ELSE IF(PERS.EQ.'SL35') THEN
          ZCUT=1893.
          CALL GDRAWC('MUON',3,ZCUT-ZMUON,10.,12.,.02,.02)
      ELSE IF(PERS.EQ.'SL36') THEN
          ZCUT=1898.
          CALL GDRAWC('MUON',3,ZCUT-ZMUON,10.,12.,.02,.02)
      ELSE IF(PERS.EQ.'SL41') THEN
          ZCUT=1960.
          CALL GDRAWC('MUON',3,ZCUT-ZMUON,10.,12.,.02,.02)
      ELSE IF(PERS.EQ.'SL42') THEN
          ZCUT=1961.1
          CALL GDRAWC('MUON',3,ZCUT-ZMUON,10.,12.,.02,.02)
      ELSE IF(PERS.EQ.'SL43') THEN
          ZCUT=1966.5
          CALL GDRAWC('MUON',3,ZCUT-ZMUON,10.,12.,.02,.02)
      ELSE IF(PERS.EQ.'SL44') THEN
          ZCUT=1969.
          CALL GDRAWC('MUON',3,ZCUT-ZMUON,10.,12.,.02,.02)
      ELSE IF(PERS.EQ.'SL45') THEN
          ZCUT=1973.1
          CALL GDRAWC('MUON',3,ZCUT-ZMUON,10.,12.,.02,.02)
      ELSE IF(PERS.EQ.'SL46') THEN
          ZCUT=1979.
          CALL GDRAWC('MUON',3,ZCUT-ZMUON,10.,12.,.02,.02)
      ENDIF



      RETURN
      END






