*-- Author :    Hartwig Albrecht   19/10/95

      SUBROUTINE KAEVEN

************************************************************************
*
* Description: EVENTNO command
*
* Called from: KUIP
*
* External references:
*
* Argument in/out description
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"

      INTEGER I

#include "arte/Arte.ff"

      CALL KUGETI (NUMEVT)
      IF (NUMEVT .LE. 0)  CALL MEWARC (651345,
     +  'EVENTNO: event number should be positive')

      CALL KUGETI (I)
      IF (I .LT. 0)  CALL MEWARC (563476,
     +  'EVENTNO: run number should be positive')
      IF (I .NE. 0)  NUMRUN = I

      CALL KUGETI (I)
      IF (I .GT. 0)  CALL MEERRC (763456,
     +  'EVENTNO: experiment number must be negative')
      IF (I .EQ. 0)  NUMEXP = -INSTNUM

      IF (NUMEXP .EQ. 0)  THEN
        CALL MEERRC (314554,
     +    'EVENTNO: Unknown institution; exp. number set to -9999')
        NUMEXP = -9999
      END IF

      END

************************************************************************
* End of KAEVEN
************************************************************************
