*CMZ :  1.00/00 28/11/94  20.00.40  by  Fedor Ratnikov
*-- Author :    Dominik Ressing   10/10/94
************************************************************************
*
* L1DETVA
* written by Dominik Ressing, 10/10/94 19.49.06
*
* This routines action:
* returns  number of superlayers and sections for detector iSL
*
* Arguments  kind         description
*          (in,update,out)
*----------------------------------------------------------------------*
* iSL         in          sequential detector identifier
* nLay        out         # of layers for iSL
* nSec        out         # of sections for iSL
*
************************************************************************
c
      SUBROUTINE L1DETVA(iSL,nLay,nSec)
c
      IMPLICIT NONE
c
#include "gean/gcbank.fi"
#include "l1si/l1param.fi"
#include "l1si/l1clink.fi"
#include "l1si/l1detuse.fi"
#include "l1si/l1geodf.fi"
#include "l1si/l1detdf.fi"
c
      INTEGER isl,nLay,nSec,JDET
c
      IF (isl.GT.l1nDetUsed) THEN          ! detector valid ??
         nLay = 0
         nSec = 0
      ELSE
         JDET = LQ(L1JDET-isl)             ! pointer to SL begining
         nLay = IQ(JDET+L1GEOINFlen+L1DETINFnlay)
         nSec = IQ(JDET+L1GEOINFlen+L1DETINFnsec)
      ENDIF
c
      RETURN
c
      END
