*CMZ :          23/08/96  17.19.51  by  Unknown
*-- Author :     Ivan Belyaev   05/11/95

      SUBROUTINE L1EXTHP( iR , Z )

************************************************************************
*
* Description:
*
* Called from:
*
* External references:
*
* Argument in/out description
*
* iR -     in      row number in the bank Jl1pr
*
* Z  -     in      z-coordinate of extrapolation
*
************************************************************************

      IMPLICIT NONE
#include "arte/Arte.fi"
#include "l1si/rclink.fi"
#include "l1si/l1param.fi"
#include "l1si/l1geodf.fi"
#include "l1si/l1mesdf.fi"
#include "l1si/yl1hpt.fi"
#include "l1si/rcfdef.fi"
#include "l1si/ydef.fi"
#include "l1si/l1clink.fi"

      INTEGER iR , iC , iStatus(3) ,
     &  Number , nRoI , i , iNumber,iZ,
     &  NumOfZones
      REAL    Z , rMessages(0:L1GEOINFlen,2),
     & A(2),B(2), rDistance , TrackMinDistance,
     & NewDistance 
      INTEGER iMCfound , iMC

      REAL    RoI1( 0:L1ROIlen ) , RoI2( 0:L1ROIlen )
      REAL    RoI3( 0:L1ROIlen ) , RoI4( 0:L1ROIlen )
      REAL    RoI5( 0:L1ROIlen )
c
      REAL     Cell1RoI( L1GEOINFlen )
      REAL     Cell2RoI( L1GEOINFlen )
      REAL     Cell3RoI( L1GEOINFlen )

      INTEGER  JBYT
      EXTERNAL JBYT


c***
      REAL    xCell1Size,yCell1Size,Diff,XL(2),XR(2),
     &        X_MIN(2),X_MAX(2),AY,BY,rDist,x0
      INTEGER iPath , iPathSign
c***
      REAL     xTuple( 38)
      CHARACTER*4 chnames( 38)

       logical lfirst
       save lfirst

      data  chnames /'rdis','x   ','y   ','z   ',
     &               'x0  ','y0  ','z0  ','dx  ',
     &               'dy  ','cell','path','xp  ',
     &               'yp  ','pxv ','pyv ','pzv ',
     &               'ntpt','nth ','pxh ','pyh ',
     &               'ph  ','x3  ','y3  ',
     &               'x01 ','sx1 ','y01 ','sy1 ','z1  ',
     &               'x02 ','sx2 ','y02 ','sy2 ','z2  ',
     &               'x03 ','sx3 ','y03 ','sy3 ','z3  '/

       data lfirst /.true./

#include "arte/Arte.ff"
#include "l1si/rcfunc.ff"
#include "l1si/yl1hpt.ff"
#include "l1si/ydef.ff"

      If( lfirst )THEN
       CALL HBOOKN( 2017,
     & 'ntupel(moi)l1exthf$',38,'//L1PAW',5000,chnames)
       lfirst = .false.
      endif

      IF( JL1PR   .LE. 0 .OR.
     &    NL1PR() .LE. 0 .OR.
     &    iR      .LE. 0 .OR.
     &    NL1PR() .LT. iR ) THEN
ctmp       C78='L1EXThp::==> invalid Row Number'
ctmp       CALL ME78AP
       WRITE(*,*)'L1EXThp::==> invalid Row Number'
       RETURN
      ENDIF

      iC = iR

      iStatus(3) = IL1PR_PATH(iC)
      iStatus(1) = IL1PR_MTRA(iC)
      rDistance  = FL1PR_RDIS(iC)
      Number = 0

      Cell1Roi(L1GEOINFx0) = FL1PR_L1X0(iC)
      Cell2Roi(L1GEOINFx0) = FL1PR_L2X0(iC)
      Cell3Roi(L1GEOINFx0) = FL1PR_L3X0(iC)
      Cell1Roi(L1GEOINFsx) = FL1PR_L1SX(iC)
      Cell2Roi(L1GEOINFsx) = FL1PR_L2SX(iC)
      Cell3Roi(L1GEOINFsx) = FL1PR_L3SX(iC)
      Cell1Roi(L1GEOINFy0) = FL1PR_L1Y0(iC)
      Cell2Roi(L1GEOINFy0) = FL1PR_L2Y0(iC)
      Cell3Roi(L1GEOINFy0) = FL1PR_L3Y0(iC)
      Cell1Roi(L1GEOINFsy) = FL1PR_L1SY(iC)
      Cell2Roi(L1GEOINFsy) = FL1PR_L2SY(iC)
      Cell3Roi(L1GEOINFsy) = FL1PR_L3SY(iC)
      Cell1Roi(L1GEOINFz ) = FL1PR_L1Z (iC)
      Cell2Roi(L1GEOINFz ) = FL1PR_L2Z (iC)
      Cell3Roi(L1GEOINFz ) = FL1PR_L3Z (iC)


       CALL l1kine1( Cell1RoI , Cell3RoI ,
     &  0.0  , 1000.0 , Z ,
     &  nRoI , RoI2   , RoI5 )
       RoI2( L1ROIreg + L1GEOINFsin_al ) = 0.0
       RoI2( L1ROIreg + L1GEOINFcos_al ) = 1.0
       CALL l1kine1( Cell1RoI , Cell2RoI ,
     &  0.0  , 1000.0 , Z ,
     &  nRoI , RoI3   , RoI5 )
       RoI3( L1ROIreg + L1GEOINFsin_al ) = 0.0
       RoI3( L1ROIreg + L1GEOINFcos_al ) = 1.0
       CALL l1kine1( Cell2RoI , Cell3RoI ,
     &  0.0  , 1000.0 , Z ,
     &  nRoI , RoI4   , RoI5 )
       RoI4( L1ROIreg + L1GEOINFsin_al ) = 0.0
       RoI4( L1ROIreg + L1GEOINFcos_al ) = 1.0
       CALL l1detis( RoI2( L1ROIreg + 1 )  ,
     &               RoI3( L1ROIreg + 1 )  ,
     &               RoI5( L1ROIreg + 1 )  )
       RoI5(  L1ROIreg + L1GEOINFsin_al ) = 0.0
       RoI5(  L1ROIreg + L1GEOINFcos_al ) = 1.0
       RoI5(  L1ROIreg + L1GEOINFx0 ) =
     &  RoI5( L1ROIreg + L1GEOINFx0 ) -
     &  RoI5( L1ROIreg + L1GEOINFsx ) * 0.025
       RoI5(  L1ROIreg + L1GEOINFy0 ) =
     &  RoI5( L1ROIreg + L1GEOINFy0 ) -
     &  RoI5( L1ROIreg + L1GEOINFsy ) * 0.025
       RoI5(  L1ROIreg + L1GEOINFsx ) =
     &  RoI5( L1ROIreg + L1GEOINFsx ) * 1.050
       RoI5(  L1ROIreg + L1GEOINFsy ) =
     &  RoI5( L1ROIreg + L1GEOINFsy ) * 1.050

       IF( RoI5( L1ROIreg + L1GEOINFsx )
     &          .LE. 0.0     .OR.
     &     RoI5( L1ROIreg + L1GEOINFsy )
     &          .LE. 0.0 ) THEN
ctmp        C78='LEXTHF==> error,contradiction Roi2,4'
ctmp        CALL ME78AP
        WRITE(*,*)'LEXTHF==> error,contradiction Roi2,4'
        DO i = 0 , L1ROIlen
         RoI5( i ) = RoI2( i )
        ENDDO
       ENDIF

       CALL l1detis( RoI5( L1ROIreg + 1 ) ,
     &               RoI4( L1ROIreg + 1 ) ,
     &               RoI1( L1ROIreg + 1 ) )
       RoI1(  L1ROIreg + L1GEOINFsin_al ) = 0.0
       RoI1(  L1ROIreg + L1GEOINFcos_al ) = 1.0
       RoI1(  L1ROIreg + L1GEOINFx0 ) =
     &  RoI1( L1ROIreg + L1GEOINFx0 ) -
     &  RoI1( L1ROIreg + L1GEOINFsx ) * 0.250
       RoI1(  L1ROIreg + L1GEOINFsx ) =
     &  RoI1( L1ROIreg + L1GEOINFsx ) * 1.500
       RoI1(  L1ROIreg + L1GEOINFy0 ) =
     &  RoI1( L1ROIreg + L1GEOINFy0 ) -
     &  RoI1( L1ROIreg + L1GEOINFsy ) * 0.050
       RoI1(  L1ROIreg + L1GEOINFsy ) =
     &  RoI1( L1ROIreg + L1GEOINFsy ) * 1.100

       IF( RoI1( L1ROIreg + L1GEOINFsx )
     &     .LE. 0.0     .OR.
     &     RoI1( L1ROIreg + L1GEOINFsy )
     &     .LE. 0.0 ) THEN
ctmp        C78='LEXTHF==> error,contradiction Roi5,3'
ctmp        CALL ME78AP
        WRITE(*,*)'LEXTHF==> error,contradiction Roi5,3'
        DO i = 0 , L1ROIlen
         RoI1( i ) = RoI5( i )
        ENDDO
       ENDIF

       Number = 1

       rMessages( L1GEOINFz  ,  1  ) =
     &  RoI1(     L1GEOINFz  + L1ROIreg )
       rMessages( L1GEOINFx0 ,  1  ) =
     &  RoI1(     L1GEOINFx0 + L1ROIreg )
       rMessages( L1GEOINFsx ,  1  ) =
     &  RoI1(     L1GEOINFsx + L1ROIreg )
       rMessages( L1GEOINFy0 ,  1  ) =
     &  RoI1(     L1GEOINFy0 + L1ROIreg )
       rMessages( L1GEOINFsy ,  1  ) =
     &  RoI1(     L1GEOINFsy + L1ROIreg )

       rMessages( L1GEOINFz  ,  2  ) =
     &  RoI1(     L1GEOINFz  + L1ROIreg )
       rMessages( L1GEOINFx0 ,  2  ) =
     &  RoI1(     L1GEOINFx0 + L1ROIreg )
       rMessages( L1GEOINFsx ,  2  ) =
     &  RoI1(     L1GEOINFsx + L1ROIreg )
       rMessages( L1GEOINFy0 ,  2  ) =
     &  RoI1(     L1GEOINFy0 + L1ROIreg )
       rMessages( L1GEOINFsy ,  2  ) =
     &  RoI1(     L1GEOINFsy + L1ROIreg )


c corrections ( follow by Pavlick Pakhlov )

      x0         =   rMessages( L1GEOINFx0 , 1 )
     &     + 0.5 *   rMEssages( L1GEOINFsx , 1 )
      xCell1Size =   Cell1RoI( L1GEOINFsx )
      yCell1Size =   Cell1RoI( L1GEOINFsx )
      iPath      =   IL1PR_PATH( iC )
      rDist      =   FL1PR_RDIS( iC )
      Diff       =
     & ( ( Cell2RoI( L1GEOINFx0 )         +
     &    Cell2RoI( L1GEOINFsx ) * 0.5 ) *
     &    Cell3RoI( L1GEOINFz  )         /
     &    Cell2RoI( L1GEOINFz  )         -
     &  ( Cell3RoI( L1GEOINFx0 )         +
     &    Cell3RoI( L1GEOINFsx ) * 0.5   ) ) /
     &    Cell3Roi( L1GEOINFsx  )
      IF( Diff .LE. 0 ) THEN
       IF( iPath .EQ. 50  ) iPath =  49
       IF( iPath .EQ. 150 ) iPath = 149
      ELSE
       IF( iPath .EQ. 50  ) iPath =  51
       IF( iPath .EQ. 150 ) iPath = 151
      ENDIF
      IF( iPath .LE. 100 ) THEN
       iPathSign = -1
      ELSE
       iPathSign =  1
      ENDIF

      IQ(IQL1PR_PATH( iC ) ) = iPath

c**      GO TO 600

      IF(     iPath .EQ. 49 )THEN
       Number =    1
       A( 1 ) =   -1.0
       B( 1 ) =    0.3
      ELSEIF( iPath .EQ. 51 )THEN
       Number =    1
       A( 1 ) =   -0.5
       B( 1 ) =    0.6
      ELSEIF( iPath .EQ. 99 )THEN
       IF( rDist .LE. 35 ) THEN
        Number =   2
       ELSE
        Number =   1
       ENDIF
       A( 1 ) =   -1.0
       B( 1 ) =    0.2
       A( 2 ) =    0.4
       B( 2 ) =    1.0
      ELSEIF( iPath  .EQ. 101 )THEN
       IF( rDist .LE. 35 ) THEN
        Number =   2
       ELSE
        Number =   1
       ENDIF
       A( 1 ) =   -0.2
       B( 1 ) =    1.0
       A( 2 ) =   -1.0
       B( 2 ) =    0.4
      ELSEIF( iPath  .EQ. 149 )THEN
       Number =    1
       A( 1 ) =   -0.55
       B( 1 ) =    0.65
      ELSEIF( iPath  .EQ. 151 )THEN
       Number =    1
       A( 1 ) =   -0.3
       B( 1 ) =    1.0
      ELSE
       WRITE(*,*)'L1EXTHP::==>Wrong Path=',iPath
      ENDIF
      IF(     rDist .LE. 20 )THEN
       AY = -0.3
       By =  0.3
      ELSEIF( rDist .LE. 30 )THEN
       AY = -0.35
       BY =  0.35
      ELSE
       AY = -0.4
       BY =  0.4
      ENDIF

      DO iNumber = 1 , Number
       rMessages( L1GEOINFx0 , iNumber ) =
     & rMessages( L1GEOINFx0 , iNumber ) +
     & ( A( iNumber ) + 1.0 ) * 0.5      *
     & rMessages( L1GEOINFsx , iNumber )
       rMessages( L1GEOINFsx , iNumber ) =
     & rMessages( L1GEOINFsx , iNumber ) *
     & ( B( iNumber ) - A( iNumber ) ) * 0.5
       rMessages( L1GEOINFy0 , iNumber ) =
     & rMessages( L1GEOINFy0 , iNumber ) +
     & ( AY + 1.0 ) * 0.5      *
     & rMessages( L1GEOINFsy , iNumber )
       rMessages( L1GEOINFsy , iNumber ) =
     & rMessages( L1GEOINFsy , iNumber ) *
     & ( BY - AY ) * 0.5
      ENDDO

600   CONTINUE



       GO TO 700



      DO iNumber = 1 , Number
       TrackMinDistance = 100000.0
       NewDistance = 100000.0
       iMCFound = 0
       DO iMC = 1 , N_U( JMIMP )
        IF( F_V( JMIMP_Z , iMC , JMIMP )
     &   .GE. 1270 ) THEN
        NewDistance =
     &   ( rMessages( L1GEOINFz , iNumber ) -
     &     F_V( JMIMP_Z , iMC , JMIMP ) /
     &     F_V( JMIMP_Z , iMC , JMIMP ) *
     &     rMessages( L1GEOINFz , iNumber ) ) ** 2
        NewDistance = NewDistance +
     &   ( rMessages( L1GEOINFx0 , iNumber ) + 0.5 *
     &     rMessages( L1GEOINFsx , iNumber ) -
     &     F_V( JMIMP_X , iMC , JMIMP ) /
     &     F_V( JMIMP_Z , iMC , JMIMP ) *
     &     rMessages( L1GEOINFz , iNumber ) ) ** 2
        NewDistance = NewDistance +
     &   ( rMessages( L1GEOINFy0 , iNumber ) + 0.5 *
     &     rMessages( L1GEOINFsy , iNumber ) -
     &     F_V( JMIMP_Y , iMC , JMIMP ) /
     &     F_V( JMIMP_Z , iMC , JMIMP ) *
     &     rMessages( L1GEOINFz , iNumber ) ) ** 2
        NewDistance = SQRT( NewDistance )
        IF(  NewDistance .LT. TrackMinDistance ) THEN
         TrackMinDistance = NewDistance
         iMCFound = iMC
        ENDIF
        ENDIF
       ENDDO
       IF( iMCFound .NE. 0 ) THEN
        xTuple( 1  ) = rDistance
        xTuple( 2  ) = F_V( JMIMP_X , iMCFound , JMIMP ) +
     &          F_V( JMIMP_TX , iMCFound , JMIMP )  *
     &        ( rMessages( L1GEOINFz , iNumber ) -
     &          F_V( JMIMP_Z  , iMCFound , JMIMP ) )
        xTuple( 3  ) = F_V( JMIMP_Y , iMCFound , JMIMP ) +
     &          F_V( JMIMP_TY , iMCFound , JMIMP )  *
     &        ( rMessages( L1GEOINFz , iNumber ) -
     &          F_V( JMIMP_Z  , iMCFound , JMIMP ) )
        xTuple( 4  ) = F_V( JMIMP_Z , iMCFound , JMIMP )
        xTuple( 5  ) = rMessages( L1GEOINFx0 , iNumber ) + 0.5 *
     &                 rMessages( L1GEOINFsx , iNumber )
        xTuple( 6  ) = rMessages( L1GEOINFy0 , iNumber ) + 0.5 *
     &                 rMessages( L1GEOINFsy , iNumber )
        xTuple( 7  ) = rMessages( L1GEOINFz  , iNumber )
        xTuple( 8  ) = rMessages( L1GEOINFsx , iNumber ) / 2
        xTuple( 9  ) = rMessages( L1GEOINFsy , iNumber ) / 2
        xTuple( 10 ) = Cell1RoI( L1GEOINFsx )
        xTuple( 11 ) = iStatus( 3 )
        xTuple( 12 ) =xTuple(2)/xTuple(4)*xTuple(7)
        xTuple( 13 ) =xTuple(3)/xTuple(4)*xTuple(7)
        IF( iStatus( 1 ) .NE. 0 ) THEN
         xTuple( 14 ) =F_V(1,iStatus(1),JMTRA)
         xTuple( 15 ) =F_V(2,iStatus(1),JMTRA)
         xTuple( 16 ) =F_V(3,iStatus(1),JMTRA)
        ELSE
         xTuple( 14 ) = 0
         xTuple( 15 ) = 0
         xTuple( 16 ) = 0
        ENDIF
        xTuple( 17 ) = iStatus( 1 )
        xTuple( 18 ) = I_V( JMIMP_MTRA , iMCFound , JMIMP )
        xTuple( 19 ) = F_V( JMIMP_P , iMcFound , JMIMP ) *
     &   F_V( JMIMP_TX , iMcFound , JMIMP ) /
     &   SQRT( 1.0 + F_V(JMIMP_TX,iMCFound,JMIMP)**2+
     &               F_V(JMIMP_TY,iMCFound,JMIMP)**2)
        xTuple( 20 ) = F_V( JMIMP_P , iMcFound , JMIMP ) *
     &   F_V( JMIMP_TY , iMcFound , JMIMP ) /
     &   SQRT( 1.0 + F_V(JMIMP_TX,iMCFound,JMIMP)**2+
     &               F_V(JMIMP_TY,iMCFound,JMIMP)**2)
        xTuple( 21 ) = F_V(JMIMP_P,iMCFound,JMIMP)

c        xTuple( 22 ) = PreTrigger( L1GEOINFx0 , 3 ) +
c     &            0.5 * PreTrigger( L1GEOINFsx , 3 )
c        xTuple( 23 ) = PreTrigger( L1GEOINFy0 , 3 ) +
c     &            0.5 * PreTrigger( L1GEOINFsy , 3 )

        xTuple( 24 ) = FL1PR_L1X0(iC)
        xTuple( 25 ) = FL1PR_L1SX(iC)
        xTuple( 26 ) = FL1PR_L1Y0(iC)
        xTuple( 27 ) = FL1PR_L1SY(iC)
        xTuple( 28 ) = FL1PR_L1Z (iC)
        xTuple( 29 ) = FL1PR_L2X0(iC)
        xTuple( 30 ) = FL1PR_L2SX(iC)
        xTuple( 31 ) = FL1PR_L2Y0(iC)
        xTuple( 32 ) = FL1PR_L2SY(iC)
        xTuple( 33 ) = FL1PR_L2Z (iC)
        xTuple( 34 ) = FL1PR_L3X0(iC)
        xTuple( 35 ) = FL1PR_L3SX(iC)
        xTuple( 36 ) = FL1PR_L3Y0(iC)
        xTuple( 37 ) = FL1PR_L3SY(iC)
        xTuple( 38 ) = FL1PR_L3Z (iC)

        CALL HFN( 2017 , xTuple )
       ENDIF
      ENDDO


700   CONTINUE

      NumOfZones = Number
      IQ(IQL1PR_ZNUM(iC)) = NumOfZones
      DO iZ = 1 , NumOfZones
       Q( QL1PR_MEX0(iZ,iC)) =
     &           rMessages( L1GEOINFx0 , iZ )
       Q( QL1PR_MEY0(iZ,iC)) =
     &           rMessages( L1GEOINFy0 , iZ )
       Q( QL1PR_MESX(iZ,iC)) =
     &           rMessages( L1GEOINFsx , iZ )
       Q( QL1PR_MESY(iZ,iC)) =
     &           rMessages( L1GEOINFsy , iZ )
       Q( QL1PR_MEZ (iZ,iC)) = Z
      ENDDO

      RETURN

      END

************************************************************************
* End of L1EXTHP
************************************************************************
