        subroutine piline
*********************************************************
*
* Draws line.
* If coordinates are not specified, asks for graphical input with mouse.
*
* Author: Alexander Lanyov   Oct 1999.
*
*********************************************************
        implicit none

#include "pris/zgraf.fi"

        real x(2),y(2),wid,col,dist,tx,x0
        integer nt,istat

        call kugetr(x(1))
        call kugetr(y(1))
        call kugetr(x(2))
        call kugetr(y(2))
        call kugetr(col)
        call kugetr(wid)

        dist = sqrt((x(1)-x(2))**2 + (y(1)-y(2))**2)
        if (dist.eq.0.) then

           call igsa(1)                 ! alphanumeric mode
           print *,' use rubberband to select 2-point line'
           call igsg(1)                 ! graphic mode
           call iuwk(0,1)
           nt = nt_framzg
           call igloc2(1,nt,x(1),y(1),x(2),y(2),istat,'PL')
           call igsa(1)                 ! alphanumeric mode
           write (*,1) x(1),y(1),x(2),y(2)
 1         format(' You selected line between x1,y1 =',2f8.2,
     @                                  ' and x2,y2 =',2f8.2)

           dist = sqrt((x(1)-x(2))**2 + (y(1)-y(2))**2)
           write (*,*) 'Distance between line ends is',dist,' cm.'

           if ((x(2)-x(1)) .ne. 0.) then
              tx = (y(2)-y(1))/(x(2)-x(1))
              x0 = y(1) - tx*x(1)
              write (*,*) 'tx =',tx,' x0 =',x0
           end if

           if (nt.le.0) then
              print *,' outside of borders ... please try again'
              print *,' nt=', nt
              return
           end if
        end if

        if (col .ne. 0.) then
           call igset('PLCI',col)
        end if
        call islwsc(wid)
        call ipl(2,x,y)

        call iuwk(0,1)
        return
        end
