// 
//  Author:  Rainer Mankel                     Created:  12-Jul-99
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

// class rangerExclusionRange
// specify contiguous range of unuseable channels

#include "rang/LayPl.hh"
#include "rang/ExclusionRange.hh"

rangerExclusionRange::rangerExclusionRange(rangerLayPl* laypl,
					   double uMin,double uMax){
  lPl = laypl;
  uMi = uMin;
  uMa = uMax;
}

void rangerExclusionRange::extend(double uemin,double uemax){

  if (uemin < uMi && uemax > uMi) uMi = uemin;
  if (uemax > uMa && uemin < uMa) uMa = uemax;

}
 
