#ifndef _rgExtDef_hh_
#define _rgExtDef_hh_
//------------------------------------------------------------------------
// Created: 19.05.99 by   Alexander Spiridonov for ranger external  
//------------------------------------------------------------------------


// Prototypes

extern "C" {
  void hf1_(int& id, float& value, float& weight);
  void hf2_(int& id, float& xv, float& yv, float& weight);
  void tfremcse_(int&, int&, float&);
  void rgextini_();
  int rgmc_();
  void rgextreco_();
  void rgextvmrse_();
  void rgextcrse_();
  void rgextmrse_();
  void rgextmoms_();
  void rgextmass_(int update,int vds, float mass0);
  void rgextspr_();
  void tfhbinit_();
  void rgextsvm_(float&, float*, float&, float*);
  void rgextsmv_(float&, float*, float&, float*);
  void rk5clip_(double&, double*, double&, double*,double*, int&);
  void rgextkuip();
  void rgextios_(const int& ios_seed); // =0 not save, =1 saved in RSEG

  float tfqptest_(float&, float&, float&);
  float tfextre_();
  float tfextstat_();
}

void rgextvdmu(ArteTableIterator <RSEG>& segmu
	       ,ArteTableIterator <RSEG>& segvd
	       ,float* p_vdmu, int& OK_vdmu);

void rgextvdmuri(ArteTableIterator <RSEG>& segvd
		 ,ArteTableIterator <RSEG>& segmu
		 ,ArteTableIterator <RSEG>& segri
		 ,float* p_vdmu, int& OK_vdmuri, int& MC_vdmuri);

//#define rgExtHist

#endif


