*CMZ :  4.04/01 17/10/96  17.07.52  by  Rainer Mankel
*-- Author :    Rainer Mankel   17/10/96

      subroutine tfdbfill(dom,izf,istat)

*     **** calculate prediction from candidate endpoint izf to
*     **** domain dom and store it into db prediction buffer
      implicit none

      integer dom,izf,imc,mimp,nnmimp,ii,jj,ll,mm,istat,ipl
      real dnoise,pnoise,sum
      double precision dz,z_target,f(5,5)

#include "rang/zf.fi"
#include "rang/zfpar.fi"
#include "rang/zdomain.fi"
#include "rang/zfmode.fi"

#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "auto/MIMP.fi"
#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/MIMP.ff"

      istat = 0
      z_target = z_dm(dom)
      dz = z_target - z_zf(izf)

      if (abs(sngl(dz)).gt.dzpara_mag_zfpar) then
         call tftrkut(5,xx_zf(1,izf),dble(z_zf(izf)),z_target,
     +        x_db(1,dom),f,istat)
      else
         call tftpara(5,xx_zf(1,izf),dble(z_zf(izf)),z_target,
     +        x_db(1,dom),f,istat)
      endif
      if (istat.lt.0) then
         if (diag_level.ge.3) 
     +        print *,' tfdbfill: transport impossible (rk) '
         go to 999
      endif

*     **** propagate cov matrix
      call tuhmimp(hit_zf(izf),imc,mimp,nnmimp)
      pnoise = amax1(abs( fmimp_p(mimp) ),1.)
      ipl = plane_zf(izf)

      if (fgede_ms(ipl).gt.0.) then
       dnoise = 1.d0 * (fault_zf(izf) + 1) * fgede_ms(ipl) / pnoise**2
      elseif (igede_cmp(ipl).eq.3) then
*      **** temporary: use old MSGC value until new value available
       dnoise = 1.d0 * (fault_zf(izf) + 1) * 0.6750e-6 / pnoise**2
      else
       print *,' () tftran: no fgede_ms for ipl=', ipl
       dnoise = 0.
      endif

      do ii=1,5
       do jj=ii,5
        sum = 0.
        do ll=1,5
         do mm=1,5
          if (ll.eq.mm.and.(ll.eq.3.or.ll.eq.4)) then
           sum = sum + f(ii,ll) * (cx_zf(ll,mm,izf)+dnoise) * f(jj,mm)
          else
           sum = sum + f(ii,ll) * cx_zf(ll,mm,izf) * f(jj,mm)
          endif
         enddo
        enddo
        cx_db(ii,jj,dom) = sum
        cx_db(jj,ii,dom) = sum
       enddo
      enddo

      filled_db(dom) = .true.

 999  end

