*-- Author :    Hartwig Albrecht   22/05/95

      SUBROUTINE DDCEXT (CAPP)

************************************************************************
*
* Description: extend card CDDCRD with C syntax
*
* Called from: DD routines
*
* External references:
*
* Argument in/out description
*  CAPP    in     text to be appended
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ZDDCOM.fi"

      INTEGER L, LENOCC
      CHARACTER CAPP*(*)

#include "arte/Arte.ff"

      IF (CAPP(1:1) .EQ. '}')  NDDIND = MAX (NDDIND - 3, 1)
      L = LENOCC (CAPP)
      IF (L + NDDCRD .GT. 100)  THEN
        WRITE (LDDEF, 1001)  CDDCRD(1:LENOCC(CDDCRD))
        CDDCRD = ' '
        NDDCRD = 1
      END IF

      IF (CAPP(1:1) .NE. '#')  NDDCRD = MAX (NDDCRD, NDDIND)
      CDDCRD(NDDCRD:) = CAPP
      NDDCRD = NDDCRD + L

      DO L = 1, LEN(CAPP)
        IF (CDDCRD(L:L) .EQ. '{')  NDDIND = MIN (NDDIND + 3, 40)
        IF (L .GT. 1 .AND. CDDCRD(L:L) .EQ. '}')
     +    NDDIND = NDDIND - 3
      END DO

 1001 FORMAT (A)

      END

************************************************************************
* End of DDCEXT
************************************************************************
