#ifndef _NWAL_H_
#define _NWAL_H_
typedef struct {
   int shp;
   float xmin;
   float xmax;
   float ymin;
   float ymax;
   float zmin;
   float zmax;
   float xmad;
   float ymad;
   float zmad;
   float rot[9];
   float ms;
   int nsl;
   int onesl;
   int ogmat;
   int nede;
   char gvol[4];
   float dedx;
} NWAL;
#define  JNWAL (gcbank_.iq+artelink_.jnwal)
#define  NNWAL() N_U(JNWAL)
#define NCNWAL() N_C(JNWAL)
#define NWAL(i) (*((NWAL*)(JNWAL+2)+(i)-1))
#define NWAL_onesl(i) NWAL(i).onesl
#define NWAL_ogmat(i) NWAL(i).ogmat
#endif
