/************************************************************************
*
* ZGETFIL
* written by Siegmund Nowak
*
* This routines gives the data file name from zgvers (for Fortran users)
*
************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
#include "arte/arte.hh"
#include "gean/zgeom.h"
#include "gean/zgvers.hh"


extern "C" {  

void zgetfil_(char *filnam,int &len, int len1) {
    zgvers ZGVERS; 
    ArtePointer<NESL> sl(zgmoth_.CURRSL);   
    int cmp = sl->cmp;
    strcpy(filnam,ZGVERS.Get_vers_datafile(cmp));         
    len = strlen(filnam);
    memset(&filnam[len],' ',len1-len);
}}
  
/* zgetfil */
