*-- Author :    Serguei Moukhine   29/10/98
************************************************************************
*
* Description: List statistics for table(s)
*              There two subroutines in this file:
*              KASTATISTICS and KAASTATISTICS
*
* Called from: KUIP
*
* External references: LISTATISTICS, LIASTATISTICS
*
* Arguments: none
*
************************************************************************

      SUBROUTINE KASTATISTICS

************************************************************************
*
* Description: List statistics for table(s)
*
* Called from: KUIP
*
* External references: LISTATISTICS
*
* Arguments: none
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/MEMO.fi"

      INTEGER I, L, UTTABNF
      CHARACTER CNAM*80, CTPL*3

#include "arte/Arte.ff"
#include "auto/MEMO.ff"

      CNAM = ' '
      CALL KUGETC (CNAM, I)
      CALL KUGETC (CTPL, L)
      IF (I .EQ. 0)  GO TO 10

      I = UTTABNF (CNAM)
      IF (I .EQ. 0)  THEN
        CALL MEWARC (6123566, 'MMSTAT: unknown name ' // CNAM)
        GO TO 90
      END IF

 10   CALL LISTATISTICS (I, CTPL)

 90   END

************************************************************************
* End of KASTATISTICS
************************************************************************


      SUBROUTINE KAASTATISTICS

************************************************************************
*
* Description: List attribute statistics for table(s)
*
* Called from: KUIP
*
* External references: LIASTATISTICS
*
* Arguments: none
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/MEMO.fi"

      INTEGER I, L, UTTABNF
      CHARACTER CNAM*80, CTPL*3

#include "arte/Arte.ff"
#include "auto/MEMO.ff"

      CNAM = ' '
      CALL KUGETC (CNAM, I)
      CALL KUGETC (CTPL, L)
      IF (I .EQ. 0)  GO TO 10

      I = UTTABNF (CNAM)
      IF (I .EQ. 0)  THEN
        CALL MEWARC (6123566, 'MMSTAT: unknown name ' // CNAM)
        GO TO 90
      END IF

 10   CALL LIASTATISTICS (I, CTPL)

 90   END

************************************************************************
* End of KASTATISTICS
************************************************************************
