*
*  B.Fominykh  30.07.97
*
* pixel coincidences are used as seeds for track reconstruction
      SUBROUTINE MURPIX
C-    =================
      IMPLICIT NONE
*
#include "murec/MUCPAR.fi"
#include "murec/MUCONT.fi"
#include "murec/MUCTAB.fi"
#include "murec/MUCZDT.fi"
#include "arte/Arte.fi"
      INTEGER I1,ICL1,JCL1,I2,ICL2,JCL2,I,J,JH,IPP(4),IPWIR(4)
      REAL FAC,X11,X12,Y11,Y12,XH1,XH2,YH1,YH2
      INTEGER IRLM(4),ISTAR,IDBPR,IOUT
      DATA IRLM / 27, 28, 37, 38 /
#include "arte/Arte.ff"
C----+===1=========2=========3=========4=========5=========6=========7==********
*
* check-point - no pixels, nothing to do
      IF(NMUACL(IRLM(1))+NMUACL(IRLM(2)).LE.0) GOTO 999
      IF(NMUACL(IRLM(3))+NMUACL(IRLM(4)).LE.0) GOTO 999
      IF(JTMP8.LE.0) GOTO 999
      IF(IQ(JTMP8+1).LE.0) GOTO 999
      IF(IQ(JTMP8+2).LE.0) GOTO 999
*
* coincidence between MU3 and MU4 pixels
      FAC=SQRT(12.)
* loops over MU3 clusters
      DO 100 I1=1,NMUCLL(IRLM(1))+NMUCLL(IRLM(2))
        IF(I1.LE.NMUCLL(IRLM(1))) THEN
         ICL1=JCLPT1(IRLM(1))+I1-1
        ELSE
         ICL1=JCLPT1(IRLM(2))+I1-NMUCLL(IRLM(1))-1
        ENDIF
        JCL1=JTMP8+IQ(JTMP8+1)*(ICL1-1)+2
        X11=1000.
        X12=-1000.
        Y11=1000.
        Y12=-1000.
        DO J=IQ(JCL1+15),IQ(JCL1+16)
          JH=JTMP9+IQ(JTMP9+1)*(J-1)+2
          XH1=Q(JH+8)-FAC*Q(JH+11)
          IF(XH1.LT.X11) X11=XH1
          XH2=Q(JH+8)+FAC*Q(JH+11)
          IF(XH2.GT.X12) X12=XH2
          YH1=Q(JH+9)-FAC*Q(JH+12)
          IF(YH1.LT.Y11) Y11=YH1
          YH2=Q(JH+9)+FAC*Q(JH+12)
          IF(YH2.GT.Y12) Y12=YH2
        ENDDO
* zone of interest in MU4
        X11=X11-DXPXZN        
        X12=X12+DXPXZN        
        Y11=Y11-DYPXZN        
        Y12=Y12+DYPXZN        
*
        IF(IPRSC.GE.4)
     +  PRINT 1012,I1,ICL1,X11,X12,Y11,Y12
 1012   FORMAT(1X,'MURPIX: I1,ICL1',I3,I5,' X11,X12,Y11,Y12',4F7.2)
        IF(IPRLG.GE.4)
     +  WRITE(LLOGF,1012) I1,ICL1,X11,X12,Y11,Y12
*
* loops over MU4 clusters
        DO 80 I2=1,NMUCLL(IRLM(3))+NMUCLL(IRLM(4))
          IF(I2.LE.NMUCLL(IRLM(3))) THEN
           ICL2=JCLPT1(IRLM(3))+I2-1
          ELSE
           ICL2=JCLPT1(IRLM(4))+I2-NMUCLL(IRLM(3))-1
          ENDIF
          JCL2=JTMP8+IQ(JTMP8+1)*(ICL2-1)+2
*
        IF(IPRSC.GE.4)
     +  PRINT 1013,I2,ICL2,Q(JCL2+8),Q(JCL2+9),
     +                   Q(JCL2+11),Q(JCL2+12)
 1013   FORMAT(1X,'MURPIX: I2,ICL2',I3,I5,' X,Y,dX,dY',4F7.2)
        IF(IPRLG.GE.4)
     +  WRITE(LLOGF,1013) I2,ICL2,Q(JCL2+8),Q(JCL2+9),
     +                   Q(JCL2+11),Q(JCL2+12)
*
          IF(X11-Q(JCL2+8).GT.Q(JCL2+11)) GOTO 80
          IF(Q(JCL2+8)-X12.GT.Q(JCL2+11)) GOTO 80
          IF(Y11-Q(JCL2+9).GT.Q(JCL2+12)) GOTO 80
          IF(Q(JCL2+9)-Y12.GT.Q(JCL2+12)) GOTO 80
*
* coincidence of pixels
          IF(IPRSC.GE.3)
     +     PRINT 1011,ICL1,ICL2
          IF(IPRLG.GE.3)
     +     WRITE(LLOGF,1011) ICL1,ICL2
 1011     FORMAT(1X,'coincidence of pixels:',2I4)
*
* make a Kalman filter seed
          DO I=1,4
           IPP(I)=0
           IPWIR(I)=0
          ENDDO
          IPP(1)=ICL2
          IPP(2)=ICL1
          CALL MURBRSD(IPP,IPWIR,IOUT)
          IF(IOUT.NE.0) GOTO 80
* grouth a tree from the seed
          ISTAR=IFREE-1
          IDBPR=0
          IF(IPRLG.GE.5) IDBPR=1
          CALL MURBRGR(ISTAR,IDBPR)
*
  80    CONTINUE
 100  CONTINUE
*
 999  CONTINUE
      RETURN
      END
