#ifndef rgfitsv_HH
#define rgfitsv_HH

extern "C" {
  int rgfitsv_(const int* segVec,   // integer array of RSEG row numbers
	       const int& nSeg,     // length of this array
	       const int& pType     // particle type identifier:
	                            //    0 - MUON
	                            //    1 - PION
	                            //    2 - KAON
                                    //    3 - PROTON
	                            //    4 - ELECTRON
	       );
}
#endif
