// 
//  Author:  Alexander Spiridonov              Created:  08.07.99
//
//  Email:   spiridon@ifh.de                   HERA-B Collaboration
// 
// rgextkuip.C

#include <iostream.h>
#include <math.h>
#include <stdio.h>
#include "arte/arte.hh"
#include "gean/ZGESL.h"
#include "rang/rgExtDef.hh"
#include "rang/zfparext.hh"


// Prototypes
extern "C" {
  char* ku_getc();
  void rgextini1_();
}


void rgextkuip() {

//  cout << " Hello, this is rgextkuip " << endl;

// initialization

  rgextini1_();

//  zfparext_.id_seed_ext= 1;
//  zfparext_.id_cut_seed= 0;
//  zfparext_.id_save_seed= 0;
//  zfparext_.drift_distance = 1;

  char seed[80];
  strcpy (seed,ku_getc());
  char cut[80];
  strcpy (cut,ku_getc());
  char save[80];
  strcpy (save,ku_getc());
  char time[80];
  strcpy (time,ku_getc());
    
//  cout << "1 "<< seed[0] << " 2 " << time[0] << endl;

  switch (seed[0]) {
  case 'C':
    zfparext_.id_seed_ext = 1;
    cout << "   cluster+rich seed, " ;
    break;
  case 'V':
    zfparext_.id_seed_ext = 2;
    cout << "   vds+muon+rich seed, " ;
    break;
  case 'M':
    zfparext_.id_seed_ext = 3;
    cout << "   muon+rich seed, " ;
    break;
  default:
    zfparext_.id_seed_ext = 0;
    cout << "   user defined seed, " ;
  }

  switch (cut[0]) {
  case 'R':
    zfparext_.id_cut_seed = 1;
    cout << " rough cuts, " ;
    break;
  case 'I':
    zfparext_.id_cut_seed = 2;
    cout << " IT cuts, " ;
    break;
  default:
    zfparext_.id_cut_seed = 0;
    cout << " soft cuts, " ;
  }

  switch (save[0]) {
  case 'Y':
    zfparext_.id_save_seed = 1;
    cout << " save, " ;
    break;
  default:
    zfparext_.id_save_seed = 0;
    cout << " not save, " ;
  }

  switch (time[0]){
  case 'N':
    zfparext_.drift_distance = 0;
    cout << "no drift distance" << endl;
    break;
  default:
    zfparext_.drift_distance = 1;
    cout << "with drift distance" << endl;
  }

}
