// 
//  Author:  Rainer Mankel                     Created:  19-May-99
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

// rgwizmax_
// Fortran interface to rangerDomWin::zmax()
// Return upper z border for a given domain window.

#include "rang/DomWin.hh"

extern "C" {
  float rgwizmax_(rangerDomWin*& dw) {
    if (dw) {
      return dw->zmax();
    }
    else {
      return 0;
    }
  }
}



    



