// 
//  Author:  Rainer Mankel                     Created:  25-Apr-99
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

// rgxproclr_
// Erase the horizontal projection candidate stored in the global
// domain object.

#include "rang/DomObj.hh"
#include "rang/XPro.hh"

extern rangerDomObj* rangerDO;   // global DO pointer

extern "C" {
  void rgxproclr_() {
    rangerDO->xpro()->clr();
  }
}
