*-- Author :    A.Spiridonov   04/09/98

      subroutine tfremcse(iseg,imcass,fracmc)

*     **** for segment iseg define assigned MC imcass and fracmc

      implicit none

#include "arte/Arte.fi"
#include "auto/HITB.fi"
#include "auto/MTRA.fi"
#include "auto/RTRA.fi"
#include "auto/RHIT.fi"
#include "auto/RSEG.fi"

      integer iseg, imcass
      integer nhit,hit,imc,jaux,max_ass,nmxass,jmcass,ind_hit,iihitb
      real fracmc
      parameter (nmxass=40)
      integer mcass(nmxass),nmcass
      parameter (max_ass=40)
      integer i_ass,n_ass,ass(max_ass),count_ass(max_ass),mc_winner,
     +     count_winner

#include "arte/Arte.ff"
#include "auto/HITB.ff"
#include "auto/MTRA.ff"
#include "auto/RTRA.ff"
#include "auto/RHIT.ff"
#include "auto/RSEG.ff"

*     **** calculate for reconstructed segment ISEG  the
*     **** associated MC particle

      n_ass = 0

*     **** loop over hits used for track
      nhit = 0

#ifdef TC_TEST
******
      do 10 iihitb=1,999        ! locate hits associated with track
         if (iihitb.eq.1) then
            ind_hit = prtra_hitb(it)
         else
            ind_hit = xrtra_hitb(ind_hit)
         endif
         if (ind_hit.le.0) go to 11
         hit = mrtra_hitb(ind_hit)
         nhit = nhit + 1
*****
#endif

      do 10 iihitb=1,999        ! locate hits associated with segment
        if(iihitb.eq.1) then
          ind_hit = prseg_rhit(iseg)
        else
          ind_hit = xrseg_rhit(ind_hit)
        end if
        if (ind_hit.le.0) go to 11
        hit = mrseg_rhit(ind_hit) 
        hit = orhit_hitb(hit)
        nhit = nhit + 1

*        **** locate MC particles associated with this hit

         call tumclo(hit,nmxass,nmcass,mcass)
 
*         print '("tfremcse : nhit,hit,nmcass ",3i5)',nhit,hit,nmcass


*        **** loop over associated MC particles
         do jmcass=1,nmcass
            imc = mcass(jmcass)
            if (imc.lt.1.or.imc.gt.iq(jmtra+2)) then
               print *,' () tfremcn: invalid imc=', imc
               imc = 0
            endif

            do i_ass=1,n_ass    ! check if already registered
               if (ass(i_ass).eq.imc) then
                  count_ass(i_ass) = count_ass(i_ass) + 1

*                  print'("tfremcse : i_ass,imc,cou ",3i5)'
*     +                   ,i_ass,imc,count_ass(i_ass)

                  go to 20
               endif
            enddo

            if (n_ass.lt.max_ass) then
               n_ass = n_ass + 1 ! register
               ass(n_ass) = imc
               count_ass(n_ass) = 1

*                  print'("tfremcse : n_ass,imc,cou ",3i5)'
*     +                   ,n_ass,imc,count_ass(i_ass)

            else
               print *,' () tfremcn: overflowing n_ass=', n_ass
            endif
 20         continue
         enddo

 10    continue
       print *,' () tfremcse: loop finished'
 11    continue

*      **** get maximum
       mc_winner = 0
       count_winner = 0

       do i_ass=1,n_ass
          if (count_ass(i_ass).gt.count_winner) then
             mc_winner = ass(i_ass)
             count_winner = count_ass(i_ass)
          endif
       enddo

       imcass = mc_winner
       fracmc = float( count_winner ) / float( nhit )

*       print '("tfremcse : iseg,nhit,ass ",2i5 )',iseg,nhit
*       print '(20(10I5))/)',(ass(i_ass),i_ass=1,n_ass)
*       print '(20(10I5))/)',(count_ass(i_ass),i_ass=1,n_ass)

       end
