*CMZ :  4.02/00 19/07/96  13.56.49  by  Rainer Mankel
*-- Author :    Rainer Mankel   22/03/96

      subroutine tftripl0(dom)

*     **** search triplets in 0-deg layers of domain

*     **** simple three-loop procedure, more sophistication later!
      implicit none
#include "rang/zdomain.fi"

      integer iih1, iih2, iih3, idh1, idh2, idh3, lay(3), hit1, hit2,
     +     hit3, cmp1, cmp2, cmp3, dom, win
      real w1, w3, d1, d2, d3, x2int, dmax
#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "auto/HITB.fi"
#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"

      print *,' trtripl: dom=',dom,' win1=', win1_dm(dom)

      do win=win1_dm(dom),win1_dm(dom)+nwin_dm(dom)-1
     +                          ! loop over domain windows
         print *,' tftripl0: check win=', win
         if (nlayer_dw(2,win).ge.3) then ! require 3 zero lyrs
            lay(1) = layer1_dw(2,win)
            lay(2) = nxtlay_dl(2,lay(1))
            lay(3) = nxtlay_dl(2,lay(2))
            print *,' tftripl0: dom layers=', lay

            do iih1=1,9999           ! loop over hits in first layer
               if (iih1.eq.1) then
                  idh1 = hit1_dp(lay(1))
               else
                  idh1 = nxthit_dh(idh1)
               endif

               if (idh1.eq.0) go to 11
               hit1 = hitb_dh(idh1)
               cmp1 = igede_cmp(ihitb_gede(hit1))
               d1 = fgede_dod(ihitb_gede(hit1))

               do 20 iih3=1,9999   ! loop over hits in third layer
                  if (iih3.eq.1) then
                     idh3 = hit1_dp(lay(3))
                  else
                     idh3 = nxthit_dh(idh3)
                  endif

                  if (idh3.eq.0) go to 21
                  hit3 = hitb_dh(idh3)
                  cmp3 = igede_cmp(ihitb_gede(hit3))
                  d3 = fgede_dod(ihitb_gede(hit3))

*                 **** check x-difference
                  if (abs(fhitb_x(hit3)-fhitb_x(hit1)).gt.
     +                 (abs(fhitb_z(hit3)-fhitb_z(hit1))+d1+d3))
     +                 go to 20

                  do iih2=1,9999 ! loop over hits in second layer
                     if (iih2.eq.1) then
                        idh2 = hit1_dp(lay(2))
                     else
                        idh2 = nxthit_dh(idh2)
                     endif

                     if (idh2.eq.0) go to 31
                     hit2 = hitb_dh(idh2)
                     cmp2 = igede_cmp(ihitb_gede(hit2))
                     d2 = fgede_dod(ihitb_gede(hit2))

*                    **** interpolation
                     w1 = (fhitb_z(hit3) - fhitb_z(hit2))
     +                    / (fhitb_z(hit3) - fhitb_z(hit1))
                     w3 = (fhitb_z(hit2) - fhitb_z(hit1))
     +                    / (fhitb_z(hit3) - fhitb_z(hit1))
                     x2int =  w1 * fhitb_x(hit1)
     +                    + w3 * fhitb_x(hit3)
                     dmax = abs(w1) * d1 + abs(w3) * d3 + d2

                     if (abs(fhitb_x(hit2)-x2int).lt.dmax) then

*                       **** found
**                        call tfsttrip(hit1,hit2,hit3)

                     endif
                  enddo         ! iih2 loop
 31               continue
 20            continue         ! iih3 loop
 21            continue
            enddo               ! iih1 loop
 11         continue

         endif                  ! layers=3
      enddo                     ! domain windows

      end
