//--*-C++-*--
#ifndef RCXMESSAGE_H
#define RCXMESSAGE_h

// *****************************************************************************
//
// source:    
//
// type:      source code
//
// created:   26 Jul 2000
//	
// author:    Andreas Gellrich
//            HERA-B Collaboration
//            Humboldt-University Berlin
//            Physics Department
//            Invalidenstr. 110
//            10115 Berlin
//            Germany
//            E-mail: Andreas.Gellrich@desy.de
//
// changes:
// 26 Jul 2000 (AG) creation (code from Denis)
//
// *****************************************************************************
 
typedef enum CUTS {
  RCX_OK,
  RCX_P_MIN,
  RCX_P_MAX,
  RCX_PT_MIN,
  RCX_P_ERROR1,
  RCX_P_ERROR2,
  RCX_P_ERROR3,
  RCX_VDS_MIN_N_HIT,
  RCX_VDS_MIN_P_HIT,
  RCX_VDS_MIN_HIT,
  RCX_RICH_MIN_RAD,// 10
  RCX_RICH_MAX_RAD,
  RCX_RICH_MIN_S,
  RCX_RICH_MIN_SN,
  RCX_RICH_ID,
  RCX_ECAL_MIN_WID,
  RCX_ECAL_MIN_E,
  RCX_ECAL_MAX_E,
  RCX_EOP_MIN,
  RCX_EOP_MAX,
  RCX_TRACK_DIFF, //20
  RCX_VERTEX_CUT, 
  RCX_R2P2_CUT, 
  RCX_X2Y2_DEVIATION,
  RCX_MISSING_SEGMENTS,
  RCX_MC_CUT,
  RCX_WRONG_FIT,
  RCX_MASS_CUT,
  RCX_DECAY_Z_CUT,
  RCX_MAX_TRACK_OCCUP,
  RCX_E_SELECT, // 30
  RCX_MU_SELEC,
  RCX_WIRE_CUT,
  RCX_EXCLUDE_V0
} cuts;


#endif
