// ********************************************************************
//
//  Routine:      rc99AMUON
//  Author:       T.Oest/D.Samtleben
//
//  Description:  muon stand alone reconstruction
//
//  Modification:
//  -- call new hitb preparation MuDigi2Hitb         11/02/00 T.Oest
//
// ********************************************************************


#include <iostream.h>
#include <stdlib.h>
#include "arte/arte.hh"

extern "C" { 
void mureca_(const int &, const int &);
int  MuDigi2Hitb();
}


//*****************************************************************
// function
//*****************************************************************

int rc99AMUON(int level ) {

//==================================================================
// 1. create hits
//           md2hitb(): fills HITB table with MUON hits
//==================================================================

     if (level ==1 || level == 3) MuDigi2Hitb();

//==================================================================
// 2. reconstruction
//==================================================================

//     if (level > 1) mureca_(0,0);
       if (level > 1) mureca_(1,1); // pixel+MU2 chambers added   
//==================================================================
// return code
//==================================================================
     return 0;
}
