
// *****************************************************************************
//
// source:    rcSelectFCNC.C
//
// type:      source code
//
// created:   06 Aug 2000
//	
// author:    Dr. Andreas Gellrich
//            HERA-B Collaboration
//            Humboldt-University Berlin
//            Physics Department
//            Invalidenstr. 110
//            10115 Berlin
//            Germany
//            E-mail: Andreas.Gellrich@desy.de
//
// symbol:    rcSelectFCNC
//
// called by: rcSelectify
//
// purpose:   check for FCNC event
//
// hints:     do NOT set flagdst here!
//
// changes:
// 06 Aug 2000 (AG) creation
//
// *****************************************************************************

// ARTE includes
#include "arte/arte.hh"
#include "farm/farm.hh"

//
// function code
//
int
rcSelectFCNC()
{
  // inits
  int rc = 0;

  // invoke FCNC finder
  ARTE_mark( "rcSelectFCNC 0", 0 );

  ARTE_mark( "rcSelectFCNC 1", 0 );
  return rc;
}
