#include "OTrRead.h"
#include "OTrAsdId.h"
#include <stdio.h>

OTrASD8* OTrGetAsd(OTR_Decode* decodetable, char* asdname)
{
  OTrASD8* asdIt ;
  unsigned char sulid,layid,secid,ftbid ;
  unsigned char firstasd ;
  unsigned short asdid ;
  const OTrSuperLayer* sulit ;
  asdIt=0;
  if(asdid2num(asdname,&sulid,&layid,&secid,&ftbid)==0 && sulid<32) {
    sulit =  decodetable->Slayers + sulid ;
    firstasd = sulit->FirstASD[layid][secid] ;
    if(firstasd<255) {
      asdid = sulit->Line[sulit->pos[layid][secid] - firstasd  + ftbid] ;
      asdIt = decodetable->ASD8s[asdid] ;
    }
  }
  return asdIt ;
}

/* Wouter: obsolete, please look in waxDecodeManager.C */
/*
int OTrReadStatus(OTR_Decode* decodetable, const char* filename)
{
  OTrASD8* asdIt ;
  FILE* file ;
  char asdname[12] ;
  char statusstring[17] ;
  char line[400];
  int chanid;
  int rc;

  file = fopen(filename,"r") ;
  if(file) {
    rc=0;
    while(fgets(line,399,file)!=NULL) {
      if(line[0] != '#') {
	sscanf(line,"%s %s",asdname,statusstring) ;
	asdIt = OTrGetAsd(decodetable,asdname) ;
	printf("%s %s",asdname,statusstring) ; 
	for(chanid=0; chanid<16; chanid++) {
	  switch(statusstring[chanid]) {
	  case 'D':
	  case 'W':
	  case 'H':
	  case 'X':
	  case 'I':
	  case 'V':
	  case 'N':
	  case 'F':
	    asdIt->wire[chanid].status = 1 ;
	    break;
	  case '.':
	  case 'C':
	  default:
	    asdIt->wire[chanid].status = 0 ;
	  }
	}
      }
    }
  } else {
    rc = 1;
    printf("OTrReadMask: Could not find file %s .\n",filename) ;
  }
  return rc;
}
*/

int OTrReadTZero(OTR_Decode* decodetable, const char* filename)
{
  OTrASD8* asdIt ;
  FILE* file ;
  char asdname[12];
  int tzc,tzec,chanid ;
  int rc;

  file = fopen(filename,"r") ;
  if(file) {
    rc=0;
    while(fscanf(file,"%s",asdname)!=EOF) {
      asdIt = OTrGetAsd(decodetable,asdname) ;
      for(chanid=0; chanid<16; chanid++) {
	fscanf(file,"%d",&tzc) ;
	fscanf(file,"%d",&tzec) ;
	asdIt->wire[chanid].tzero = tzc ;
	asdIt->wire[chanid].tzerr = tzec ;
      }
    }
  } else {
    rc=1;
    printf("OTrReadTZero: Could not find file %s .\n",filename) ;
  }
  return rc ;
}
